/* dos2unix by Erik Greenwald
 * I KNOW this program already exists, but I figured it'd take just as long
 * to find it as to write it :) plus more fun to write it. So this is my 
 * implementation of unix2dos, I don't know how the real one works.
 * oct 03 1998
 * this sucker *SHOULD* be fully portable...
 *
 * can be used as a pipe (stdin/stdout) or given files to convert
 */

#include <stdio.h>

#define TMP 0
#define FIL 1

void showhelp(char *name){
	fprintf(stdout,"Usage:\n\t%s <file 1> [file 2] ... [file n]\n\t\tConverts files to unix format\n\n\t<command> | %s\n\t\tConverts stdin and outputs to stdout (pipe)\n\n\t%s <-h|--help>\n\t\tThis useless help screen\n\n",name,name,name);
	exit(0);
	}

void showerr(int type){
	fprintf(stderr,"Error: ");
	switch(type){
		case TMP:
			fprintf(stderr,"Couldn't make temp file\n"); break;
		case FIL:
			fprintf(stderr,"Couldn't open file\n"); break;  
		default:
			fprintf(stderr,"Couldn't figure out the error even!\n"); break;
		}
	exit(-1);
	}
	
void ungarble(FILE *in,FILE *out){
	char b;
	while((b=getc(in))!=EOF)if(b!='\x0d')fputc(b,out); 
	}

int main(int argc, char **argv){
	int n;	
	if(argc>1){
		FILE *f, *t;
		char buf;
		if(!(strcmp(argv[1],"-h")||strcmp(argv[1],"--help")))showhelp(argv[0]);
		for(n=1;n<argc;n++){
			if((f=fopen(argv[n],"r+b"))==NULL)showerr(FIL);
			if((t=tmpfile())==NULL)showerr(TMP);
			while((buf=getc(f))!=-1)putc(buf,t);
			fflush(NULL);
			fclose(f);
			if((f=fopen(argv[n],"wb"))==NULL)showerr(FIL);
			rewind(t);
			ungarble(t,f);
			fclose(f); fclose(t);
			}
		}
	else if(argc==1){
		ungarble(stdin,stdout);
		}
	else fprintf(stderr,"uhhhhhhhhhhhh, something's busted way bad\n\n");
	return 1;
	}
	
